﻿using Maticsoft.DBUtility;
using ZWGXPICK_SYS.Model;
using System;
using System.Data;
using System.Data.SQLite;
using System.Text;

namespace ZWGXZWGXPICK_SYS.DAL
{

    // 报警日志实现.
    public class ALARM_LOG
    {
        // 添加一条新数据.
        public int Add(ZWGXPICK_SYS.Model.ALARM_LOG model)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("insert into TB_ALARM_LOG(");
            builder.Append("log_date,log_time,log_classify,log_content)");
            builder.Append(" values (");
            builder.Append("@log_date,@log_time,@log_classify,@log_content)");
            builder.Append(";select LAST_INSERT_ROWID()");
            SQLiteParameter[] cmdParms = new SQLiteParameter[]
            {
                new SQLiteParameter("@log_date",    DbType.String),
                new SQLiteParameter("@log_time",    DbType.String),
                new SQLiteParameter("@log_classify",DbType.String),
                new SQLiteParameter("@log_content", DbType.String),
            };

            cmdParms[0].Value = model.log_date;
            cmdParms[1].Value = model.log_time;
            cmdParms[2].Value = model.log_classify;
            cmdParms[3].Value = model.log_content;
            object single = DbHelperSQLite.GetSingle(builder.ToString(), cmdParms);
            if (single == null)
            {
                return 0;
            }
            return Convert.ToInt32(single);
        }

        // 根据指定的ID获取某一行数据.
        public ZWGXPICK_SYS.Model.ALARM_LOG DataRowToModel(DataRow row)
        {
            ZWGXPICK_SYS.Model.ALARM_LOG alarm_log = new ZWGXPICK_SYS.Model.ALARM_LOG();
            if (row != null)
            {
                // model.id
                if ((row["id"] != null) && (row["ID"].ToString() != ""))
                {
                    alarm_log.id = int.Parse(row["ID"].ToString());
                }

                //model.product_model
                if ((row["log_date"] != null) && (row["log_date"].ToString() != ""))
                {
                    alarm_log.log_date = row["log_date"].ToString();
                }

                //model.product_date;
                if ((row["log_time"] != null) && (row["log_time"].ToString() != ""))
                {
                    alarm_log.log_time = row["log_time"].ToString();
                }

                //model.log_classify;
                if ((row["log_classify"] != null) && (row["log_classify"].ToString() != ""))
                {
                    alarm_log.log_content = row["log_classify"].ToString();
                }

                //model.log_content;
                if ((row["log_content"] != null) && (row["log_content"].ToString() != ""))
                {
                    alarm_log.log_content = row["log_content"].ToString();
                }
            }

            return alarm_log;
        }

        // 删除一行数据.
        public bool Delete(int id)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("delete from TB_ALARM_LOG ");
            builder.Append(" where id=@id");
            SQLiteParameter[] cmdParms = new SQLiteParameter[] { new SQLiteParameter("@id", DbType.Int32, 4) };
            cmdParms[0].Value = id;
            return (DbHelperSQLite.ExecuteSql(builder.ToString(), cmdParms) > 0);
        }

        // 清空整个表数据.
        public bool DeleteAll()
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("delete from TB_ALARM_LOG");
            return (DbHelperSQLite.ExecuteSql(builder.ToString()) > 0);
        }

        // 删除多行数据.
        public bool DeleteList(string IDlist)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("delete from TB_ALARM_LOG ");
            builder.Append(" where id in (" + IDlist + ")  ");
            return (DbHelperSQLite.ExecuteSql(builder.ToString()) > 0);
        }

        // 数据是否存在.
        public bool Exists(int id)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("select count(1) from TB_ALARM_LOG");
            builder.Append(" where id=@id");
            SQLiteParameter[] cmdParms = new SQLiteParameter[] { new SQLiteParameter("@id", DbType.Int32, 4) };
            cmdParms[0].Value = id;
            return DbHelperSQLite.Exists(builder.ToString(), cmdParms);
        }

        // 获取列表数据.
        public DataSet GetList(string strWhere)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("select id,log_date,log_time,log_classify,log_content,status");
            builder.Append(" FROM TB_ALARM_LOG ");
            if (strWhere.Trim() != "")
            {
                builder.Append(" where " + strWhere);
            }
            return DbHelperSQLite.Query(builder.ToString());
        }

        // 按分页获取列表数据.
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("SELECT * FROM ( ");
            builder.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                builder.Append("order by T." + orderby);
            }
            else
            {
                builder.Append("order by T.ID desc");
            }

            builder.Append(")AS Row, T.*  from TB_ALARM_LOG T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                builder.Append(" WHERE " + strWhere);
            }
            builder.Append(" ) TT");
            builder.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQLite.Query(builder.ToString());
        }

        // 获取最大ID.
        public int GetMaxId()
        {
            return DbHelperSQLite.GetMaxID("id", "TB_ALARM_LOG");
        }

        // 根据ID获取一条数据.
        public ZWGXPICK_SYS.Model.ALARM_LOG GetModel(int id)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("select id,log_date,log_time,log_classify,log_content,status from TB_ALARM_LOG ");
            builder.Append(" where id=@id");
            SQLiteParameter[] cmdParms = new SQLiteParameter[] { new SQLiteParameter("@id", DbType.Int32, 4) };
            cmdParms[0].Value = id;
            ZWGXPICK_SYS.Model.ALARM_LOG alarm_log = new ZWGXPICK_SYS.Model.ALARM_LOG();
            DataSet set = DbHelperSQLite.Query(builder.ToString(), cmdParms);
            if (set.Tables[0].Rows.Count > 0)
            {
                return this.DataRowToModel(set.Tables[0].Rows[0]);
            }
            return null;
        }

        // 根据条件查询数据总条数.
        public int GetRecordCount(string strWhere)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("select count(1) FROM TB_ALARM_LOG ");
            if (strWhere.Trim() != "")
            {
                builder.Append(" where " + strWhere);
            }
            object single = DbHelperSQLite.GetSingle(builder.ToString());
            if (single == null)
            {
                return 0;
            }
            return Convert.ToInt32(single);
        }

        // 根据ID更新某一行数据.
        public bool Update(ZWGXPICK_SYS.Model.ALARM_LOG model)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("update TB_ALARM_LOG set ");

            builder.Append("log_date=@log_date,");
            builder.Append("log_time=@log_time,");
            builder.Append("log_classify=@log_classify,");
            builder.Append("log_content=@log_content,");
            builder.Append("status=@status");

            builder.Append(" where id=@id");
            SQLiteParameter[] cmdParms = new SQLiteParameter[]
            {
                new SQLiteParameter("@log_date",    DbType.String),
                new SQLiteParameter("@log_time",    DbType.String),
                new SQLiteParameter("@log_classify",DbType.String),
                new SQLiteParameter("@log_content", DbType.String),
                new SQLiteParameter("@status",      DbType.String),
                new SQLiteParameter("@id",          DbType.Int32,4),
            };

            // 设置参数.
            cmdParms[0].Value = model.log_date;
            cmdParms[1].Value = model.log_time;
            cmdParms[2].Value = model.log_classify;
            cmdParms[3].Value = model.log_content;
            cmdParms[4].Value = model.status;
            cmdParms[5].Value = model.id;
            return (DbHelperSQLite.ExecuteSql(builder.ToString(), cmdParms) > 0);
        }
    }
}

