﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using ZWGXPICK_SYS.DAL;

namespace ZWGXPICK_SYS
{
    public partial class Weight_Data_Form : Form
    {
        public Weight_Data_Form()
        {
            InitializeComponent();
        }
        private float X;

        private float Y;

        private void setTag(Control cons)
        {
            foreach (Control con in cons.Controls)
            {
                con.Tag = con.Width + ":" + con.Height + ":" + con.Left + ":" + con.Top + ":" + con.Font.Size;
                if (con.Controls.Count > 0)
                    setTag(con);
            }
        }
        private void setControls(float newx, float newy, Control cons)
        {
            foreach (Control con in cons.Controls)
            {
                if (con.Tag == null) continue;
                string[] mytag = con.Tag.ToString().Split(new char[] { ':' });
                float a = Convert.ToSingle(mytag[0]) * newx;
                con.Width = (int)a;
                a = Convert.ToSingle(mytag[1]) * newy;
                con.Height = (int)(a);
                a = Convert.ToSingle(mytag[2]) * newx;
                con.Left = (int)(a);
                a = Convert.ToSingle(mytag[3]) * newy;
                con.Top = (int)(a);
                Single currentSize = Convert.ToSingle(mytag[4]) * Math.Min(newx, newy);
                con.Font = new Font(con.Font.Name, currentSize, con.Font.Style, con.Font.Unit);
                if (con.Controls.Count > 0)
                {
                    setControls(newx, newy, con);
                }
            }

        }

        void Form1_Resize(object sender, EventArgs e)
        {
            float newx = (this.Width) / X;
            float newy = this.Height / Y;
            setControls(newx, newy, this);
//             this.Text = this.Width.ToString() + " " + this.Height.ToString();
        }

        private void Weight_Data_Form_Load(object sender, EventArgs e)
        {
            this.Resize += new EventHandler(Form1_Resize);

            X = this.Width;
            Y = this.Height;


            setTag(this);
            Form1_Resize(new object(), new EventArgs());//x,y可在实例化时赋值,最后这句是新加的，在MDI时有用
            this.CenterToScreen();

            // 刷新列表框数据.
            updateListView();
        }

        private void updateListView()
        {
            // 显示所有日志数据.
            DataSet list = new WEIGHT_LOG().GetList("");
            DataTable dt = list.Tables[0];
            DataTable dtfmt = dt.Clone();
            dtfmt.Clear();

            dtfmt.Columns["is_qualified"].DataType = System.Type.GetType("System.String");//把数值列转换成字符列
            foreach (DataRow row in dt.Rows)
            {
                dtfmt.ImportRow(row);
            }

            foreach (DataRow row in dtfmt.Rows)
            {
                int isQualified = int.Parse(row["is_qualified"].ToString());
                if (isQualified == 1)
                {
                    row["is_qualified"] = "合格";
                }
                else
                {
                    row["is_qualified"] = "不合格";
                }
            }

            // 去除掉不必要的列不显示.
            dtfmt.DefaultView.Sort = "id desc";
            dtfmt.Columns.Remove("id");
            dtfmt.Columns["product_model"].ColumnName = "产品型号";
            dtfmt.Columns["product_date"].ColumnName = "日期";
            dtfmt.Columns["product_time"].ColumnName = "时间";
            dtfmt.Columns["weight"].ColumnName = "重量";
            dtfmt.Columns["is_qualified"].ColumnName = "合格/不合格";

            this.dataGridView1.DataSource = dtfmt;
            this.dataGridView1.DefaultCellStyle.Font = new Font("Microsoft YaHei", 10, FontStyle.Bold);
            this.dataGridView1.ColumnHeadersDefaultCellStyle.Font = new Font("Microsoft YaHei", 10, FontStyle.Bold);
        }

        // 清除所有数据.
        private void btnClear_Click(object sender, EventArgs e)
        {
            DialogResult dr = MessageBox.Show("您好,是否确认删除所有称重数据,清除后将不可恢复!?", "删除称重数据", MessageBoxButtons.YesNo);
            if (DialogResult.Yes == dr)
            {
                new WEIGHT_LOG().DeleteAll();
                updateListView();
            }
        }
    }
}
