﻿using Maticsoft.DBUtility;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ZWGXPICK_SYS
{
    public partial class frmWeightPort : Form
    {
        public frmWeightPort()
        {
            InitializeComponent();
        }

        private void FrmAndroidIP_Load(object sender, EventArgs e)
        {
            ChbEnable_CheckedChanged();

            IniFile ini = new IniFile(PubConstant.config_file);
            this.cbbps.Text = ini.ReadString("weight_RS232", "baud");
            this.txtWeightComName.Text = ini.ReadString("weight_RS232", "comName");
            this.txtSetSingleUpperLimit.Text = ini.ReadString("weight_RS232", "setSingleUpperLimit");
            this.txtSetAdjustmentUpperLimit.Text = ini.ReadString("weight_RS232", "setAdjustmentUpperLimit");
            this.txtSetStandardWeight.Text = ini.ReadString("weight_RS232", "setStandardWeight");
            this.txtSetAdjustmentLowerLimit.Text = ini.ReadString("weight_RS232", "setAdjustmentLowerLimit");
            this.txtSetSingleLowerLimit.Text = ini.ReadString("weight_RS232", "setSingleLowerLimit");
          
            this.CenterToParent();
        }

        private void ChbEnable_CheckedChanged(object sender = null, EventArgs e = null)
        {
           
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(this.cbbps.Text.Trim()) || !int.TryParse(this.cbbps.Text.Trim(),out var cbbps) && cbbps>0)
            {
                MessageBox.Show("【波特率】配置不正确,请输入正确的配置信息!");
                return;
            }
            if (string.IsNullOrEmpty(this.txtWeightComName.Text.Trim()))
            {
                MessageBox.Show("【设备端口】配置不正确,请输入正确的配置信息!");
                return;
            }
            if (string.IsNullOrEmpty(this.txtSetSingleUpperLimit.Text.Trim()) || !decimal.TryParse(this.txtSetSingleUpperLimit.Text.Trim(), out var setSingleUpperLimit))
            {
                MessageBox.Show("【设置单重上限】配置不正确,请输入正确的配置信息!");
                return;
            }
            if (string.IsNullOrEmpty(this.txtSetAdjustmentUpperLimit.Text.Trim()) || !decimal.TryParse(this.txtSetAdjustmentUpperLimit.Text.Trim(), out var setAdjustmentUpperLimit))
            {
                MessageBox.Show("【设置调整上限】配置不正确,请输入正确的配置信息!");
                return;
            }
            if (string.IsNullOrEmpty(this.txtSetStandardWeight.Text.Trim()) || !decimal.TryParse(this.txtSetStandardWeight.Text.Trim(), out var setStandardWeight))
            {
                MessageBox.Show("【设置标准重量】配置不正确,请输入正确的配置信息!");
                return;
            }
            if (string.IsNullOrEmpty(this.txtSetAdjustmentLowerLimit.Text.Trim()) || !decimal.TryParse(this.txtSetAdjustmentLowerLimit.Text.Trim(), out var setAdjustmentLowerLimit))
            {
                MessageBox.Show("【设置调整下限】配置不正确,请输入正确的配置信息!");
                return;
            }
            if (string.IsNullOrEmpty(this.txtSetSingleLowerLimit.Text.Trim()) || !decimal.TryParse(this.txtSetSingleLowerLimit.Text.Trim(), out var setSingleLowerLimit))
            {
                MessageBox.Show("【设置单重下限】配置不正确,请输入正确的配置信息!");
                return;
            }

            // try to initialize the content value item data.
            IniFile ini = new IniFile(PubConstant.config_file);
            ini.WriteString("weight_RS232", "baud", this.cbbps.Text.Trim());
            ini.WriteString("weight_RS232", "comName", this.txtWeightComName.Text.Trim());
            ini.WriteString("weight_RS232", "setSingleUpperLimit", this.txtSetSingleUpperLimit.Text.Trim());
            ini.WriteString("weight_RS232", "setAdjustmentUpperLimit", this.txtSetAdjustmentUpperLimit.Text.Trim());
            ini.WriteString("weight_RS232", "setStandardWeight", this.txtSetStandardWeight.Text.Trim());
            ini.WriteString("weight_RS232", "setAdjustmentLowerLimit", this.txtSetAdjustmentLowerLimit.Text.Trim());
            ini.WriteString("weight_RS232", "setSingleLowerLimit", this.txtSetSingleLowerLimit.Text.Trim());

            this.Close();
        }
    }
}
